
import java.util.*;
import java.io.*;
import java.net.*;
import com.quiotix.html.parser.*;
import com.quiotix.html.parser.HtmlDocument.Attribute;
import com.quiotix.html.parser.HtmlDocument.AttributeList;


public class DocSpider {

    public static void main(String argv[]) {
        try {
            File f = new File(argv[0]);
            f = f.getCanonicalFile();
            URL u = f.toURL();
            Map anchorMap = AnchorMapper.runMapper(u);
            /*
            System.out.println("Map contains:");
            Iterator i = anchorMap.entrySet().iterator();
            Map.Entry e;
            while (i.hasNext()) {
                e = (Map.Entry) i.next();
                System.out.print(e.getKey());
                System.out.print("\t");
                System.out.println(e.getValue());
            }
            */
            ParagraphNumberer num = new ParagraphNumberer();
            int lastArg = 3;
            if (argv.length > lastArg &&
                "-nonumber".equalsIgnoreCase(argv[lastArg])) {
                num.suppressNumbering = true;
                lastArg++;
            }
            if (argv.length > lastArg &&
                "-nostatus".equalsIgnoreCase(argv[lastArg])) {
                IncludeCrawler.DEFAULT_DOC_STATUS =
                    IncludeCrawler.STATUSES_DISABLED;
                lastArg++;
            }

            File temp = new File(argv[1] + "-temp");
            temp = temp.getCanonicalFile();

            new IncludeCrawler(temp, argv[2], anchorMap, u, num);
            new CrossReferencer(temp, new File(argv[1]), num);

            temp.delete();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    static void copyFile(InputStream in, OutputStream out) throws IOException {
        byte[] buffer = new byte[1024];
        int bytesRead;
        while ((bytesRead = in.read(buffer)) != -1)
            out.write(buffer, 0, bytesRead);
        in.close();
    }



}
